import unittest
import AutoRPE.UtilsRPE.Getter as Getter
from AutoRPE.UtilsRPE import VariablePrecision


class TestGetter(unittest.TestCase):

    # def test_get_function_type(self):
    #     from AutoRPE.UtilsRPE.Classes.Vault import Vault
    #     from AutoRPE.UtilsRPE.Classes.Subprogram import SubRoutine
    #     from AutoRPE.UtilsRPE.Classes.Variable import Variable
    #     from AutoRPE.UtilsRPE.Classes.Module import Module
    #     module = Module("dia", extension=".f90")
    #     subroutine = SubRoutine("dia_hth_dep", module)
    #     var_1 = Variable(subroutine, "Kmm", _type="integer", _dimension=1, _module=None)
    #     subroutine.accessible_var["Kmm"] = [var_1]
    #     vault = Vault()
    #     string = "LOG(Kmm)"
    #     self.assertEqual(Getter.get_function_type(string, subroutine, vault), 'integer')
    #     string = "INT(Kmm)"
    #     self.assertEqual(Getter.get_function_type(string, subroutine, vault), 'integer')
    #     string = "cmplx(Kmm)"
    #     self.assertEqual(Getter.get_function_type(string, subroutine, vault), 'complex')
    #     string = "trim(Kmm)"
    #     self.assertEqual(Getter.get_function_type(string, subroutine, vault), 'char')
    #     string = " present(Kmm)"
    #     self.assertEqual(Getter.get_function_type(string, subroutine, vault), 'logical')
    #     string = "c_loc(Kmm)"
    #     self.assertEqual(Getter.get_function_type(string, subroutine, vault), 'pointer')
    #     string = "rpe(Kmm)"
    #     self.assertEqual(Getter.get_function_type(string, subroutine, vault), 'rpe_var')
    #     string = "float(Kmm)"
    #     self.assertEqual(Getter.get_function_type(string, subroutine, vault), VariablePrecision.real_id['wp'])

    def test_type_of_real_cast_with_double_specification(self):
        string = 'real((ssh(:,:,kmm)+ssh_ref)*tmask(:,:,1),dp)'
        self.assertEqual(Getter.get_type_of_real_cast(string), 'dp')

    def test_type_of_real_cast_with_single_specification(self):
        string = 'real((ssh(:,:,kmm)+ssh_ref)*tmask(:,:,1),sp)'
        self.assertEqual(Getter.get_type_of_real_cast(string), VariablePrecision.real_id['sp'])

    def test_type_of_real_cast_no_specification(self):
        string = 'real((ssh(:,:,kmm)+ssh_ref)*tmask(:,:,1))'
        self.assertEqual(Getter.get_type_of_real_cast(string), VariablePrecision.real_id['wp'])

    def test_set_working_precision(self):
        VariablePrecision.set_working_precision("sp")
        self.assertEqual(VariablePrecision.value_of_working_precision["wp"], VariablePrecision.real_id['sp'])
        VariablePrecision.set_working_precision("dp")
        self.assertEqual(VariablePrecision.value_of_working_precision["wp"], VariablePrecision.real_id['dp'])

    def test_dimension_of_contents_1(self):
        from AutoRPE.UtilsRPE.Classes.Vault import Vault
        from AutoRPE.UtilsRPE.Classes.Subprogram import SubRoutine
        from AutoRPE.UtilsRPE.Classes.Module import Module
        import AutoRPE.UtilsRPE.Classes.SourceFile as SourceFile
        # Create dummy objects
        vault = Vault()
        dummy_file = SourceFile.SourceFile("dummy", ".f90")
        dummy_module = Module(dummy_file,".f90")
        dummy_subroutine = SubRoutine("dummy", dummy_module)

        self.assertEqual(Getter.get_dimension_of_contents("1.0", block=dummy_subroutine, vault=vault), 0)

    # def test_dimension_of_contents_2(self):
    #     from AutoRPE.UtilsRPE.Classes.Vault import Vault
    #     from AutoRPE.UtilsRPE.Classes.Subprogram import SubRoutine
    #     from AutoRPE.UtilsRPE.Classes.Module import Module
    #     import AutoRPE.UtilsRPE.Classes.SourceFile as SourceFile
    #     # Create dummy objects
    #     vault = Vault()
    #     dummy_file = SourceFile.SourceFile("dummy", ".f90")
    #     dummy_module = Module(dummy_file,".f90")
    #     dummy_subroutine = SubRoutine("dummy", dummy_module)

    #     string = "real(  ( ( z3d(:,:,:) - e3t_0(:,:,:) ) / e3t_0(:,:,:) * 100 * tmask(:,:,:) ) ** 2  )"
    #     dimension = Getter.get_dimension_of_contents(string, block=dummy_subroutine, vault=vault)
    #     self.assertEqual(dimension, 3)

    # def test_dimension_of_contents_3(self):
    #     from AutoRPE.UtilsRPE.Classes.Vault import Vault
    #     from AutoRPE.UtilsRPE.Classes.Subprogram import SubRoutine
    #     from AutoRPE.UtilsRPE.Classes.Module import Module
    #     import AutoRPE.UtilsRPE.Classes.SourceFile as SourceFile
    #     # Create dummy objects
    #     vault = Vault()
    #     dummy_file = SourceFile.SourceFile("dummy", ".f90")
    #     dummy_module = Module(dummy_file,".f90")
    #     dummy_subroutine = SubRoutine("dummy", dummy_module)

    #     string = "e1e2t(:,:) * zfwf(:,:)"
    #     dimension = Getter.get_dimension_of_contents(string, block=dummy_subroutine, vault=vault)
    #     self.assertEqual(dimension, 2)

    # def test_dimension_of_contents(self):
    #     from AutoRPE.UtilsRPE.Classes.Vault import Vault
    #     from AutoRPE.UtilsRPE.Classes.Subprogram import SubRoutine
    #     from AutoRPE.UtilsRPE.Classes.Module import Module
    #     import AutoRPE.UtilsRPE.Classes.SourceFile as SourceFile
    #     # Create dummy objects
    #     vault = Vault()
    #     dummy_file = SourceFile.SourceFile("dummy", ".f90")
    #     dummy_module = Module(dummy_file,".f90")
    #     dummy_subroutine = SubRoutine("dummy", dummy_module)

    #     cases = [
    #         ('SUM( a_i(:,:,:)%val - a_i_b(:,:,:)%val, dim=3 )', 2),
    #         ('SQRT( ( zs1(:,:)%val - zs2(:,:)%val )**2 + 4*zs12(:,:)%val**2 ) * zmsk00(:,:)', 2)
    #     ]
    #     for case, answer in cases:
    #         self.assertEqual(Getter.get_dimension_of_contents(case, block=dummy_subroutine, vault=vault), answer)

    

if __name__ == '__main__':
    unittest.main()
